#include "Connection.h"
#include "FileSystem.h"
#include "DataConnection.h"
#include "Server.h"
#include "stdio.h"
#define Printer
/********************************************************************/
/*																	*/
/* Function name : GetCommandID       								*/
/* Description   : תΪID		                        */
/*																	*/
/********************************************************************/
int GetCommandID(const char *str)
{
    static struct _Command cmds[]=
    {
		{TOK_USER,	"USER"  },
		{TOK_PASS,	"PASS"  },
		{TOK_CWD,	"CWD"   },
		{TOK_PWD,	"PWD"   },
		{TOK_PORT,	"PORT"  },
		{TOK_PASV,	"PASV"  },
		{TOK_TYPE,	"TYPE"  },
		{TOK_LIST,	"LIST"  },
		{TOK_REST,	"REST"  },
		{TOK_CDUP,	"CDUP"  },
		{TOK_RETR,	"RETR"  },
		{TOK_STOR,	"STOR"  },
		{TOK_SIZE,	"SIZE"  },
		{TOK_DELE,	"DELE"  },
		{TOK_RMD,	"RMD"   },
		{TOK_MKD,	"MKD"   },
		{TOK_RNFR,	"RNFR"  },
		{TOK_RNTO,	"RNTO"  },
		{TOK_ABOR,	"ABOR"  }, 
		{TOK_SYST,	"SYST"  },
		{TOK_NOOP,	"NOOP"  },
		{TOK_BYE,	"BYE"   },
		{TOK_QUIT,	"QUIT"  },
		{TOK_ERROR,	""      },
	};
	int i;
	for (i=TOK_USER; i<=TOK_ERROR; i++)
	if(strcmp(str,cmds[i].str)==0)
                                  return i;
}


/********************************************************************/
/*																	*/
/* Function name : Quit								                */
/* Description   : Quit a connection				                */
/*																	*/
/********************************************************************/
void Quit(int CID)
{
     //First close the socket
     shutdown(Connection[CID]->Socket,0);
     closesocket(Connection[CID]->Socket);
     closesocket(Connection[CID]->DataSocket);
     if(Connection[CID]->InUsed){
         Server[Connection[CID]->ServerID]->OnlineConnections--;
         if(Connection[CID]->State!=NotLogged)
             User[Connection[CID]->UserID]->OnlineConnections--;
     }
     //2.Make the queue
     Connection[CID]->InUsed=false;
     //3.Set some counter
     //printf("رһ%d,%d\r\n",CID, Server[Connection[CID]->ServerID]->OnlineConnections);
     //ExitThread(0);
}


/********************************************************************/
/*																	*/
/* Function name : SendEx              								*/
/* Description   : Sendչȴͽ	                    */
/*																	*/
/********************************************************************/
bool SendEx(const SOCKET s, unsigned char *sendbuff, const int nBytes)
{
     int nLeft, idx, ret;
     nLeft= nBytes;
     idx=0 ;
     //printf("Data Socket %d send size: %d\r\n",s,nBytes);
     while(nLeft > 0 )
     {
                 ret=send( s, sendbuff, nLeft, 0);// & bad thing.. ˷2Сʱԭֻ&Ĵ 
                 if(ret == SOCKET_ERROR )
                        return false;
                 nLeft-=ret;
                 idx+=ret;
     }
     return true;
}

/********************************************************************/
/*																	*/
/* Function name : Send                     						*/
/* Description   : Socket				                    */
/*																	*/
/********************************************************************/
bool Send(const SOCKET s,const char *str)
{
     int iLen=strlen(str);
     //char *nstr=malloc(iLen+2);
     //strcpy(nstr,str);
     //nstr=strcat(nstr,"\r\n");
     #ifdef Printer
     printf(">>%d:%s",s,str);
     #endif
     
     if(send( s, str, 
              iLen, 0 ) == SOCKET_ERROR )
     {
              printf("Send Error\r\n");
         return false;
     }
     //SendEx(s,str,iLen);
     return true;
}

/********************************************************************/
/*																	*/
/* Function name : CreateConnection         						*/
/* Description   : һûݼ߳		                */
/*																	*/
/********************************************************************/
int CreateConnection(int SID,SOCKET s)
{
    //printf("Socket %d is Start.\r\n",s);
    //Find Connection whose is not used.
    int i,CID=0;
    for( i =0; i< ConnectionCount;i++ )
    {
         if( ! Connection[CID]->InUsed )
         {
             CID=i;
             goto OK;
         };
         CID=i;
    }
    //If need to Create a Connetion infomation
    if( CID == ConnectionCount ){
        Connection[CID]=malloc(sizeof(struct _Connection));
        ConnectionCount++;
    }
    if( Connection[CID]->InUsed ) { 
        CID++;
        Connection[CID]=malloc(sizeof(struct _Connection));
        ConnectionCount++;
        }
OK:
    //printf("Connection %d is OK.\r\n",CID);
    //printf("Socket %d is OK.\r\n",s);
    Server[SID]->OnlineConnections++;
    Connection[CID]->Socket=s;
    Connection[CID]->ServerID=SID;
    Connection[CID]->State=NotLogged;
    Connection[CID]->UserID=-1;
    Connection[CID]->Index= CID;
    Connection[CID]->TickCount=0;
    Connection[CID]->InUsed=-1;//we use it.
    //printf("Debug Print CID:%d\r\nDebug Print ConnectionCount:%d\r\n",CID,ConnectionCount );
    DWORD ThreadID;
    //WaitingNumber=CID;
    if((Connection[CID]->ThisThread=CreateThread(NULL, 0, ConnectionInstanceProc,
			Connection[CID], 0, &ThreadID)) == NULL)
			return false;
    return CID;

}

/********************************************************************/
/*																	*/
/* Function name : ConnectionInstanceProc							*/
/* Description   : ûӵ߳(ж				        */
/*																	*/
/********************************************************************/
DWORD WINAPI ConnectionInstanceProc(LPVOID lpParameter)
{
      //int *index=lpParameter;
      //int CID=WaitingNumber;
      struct _Connection *c=(struct _Connection *)lpParameter;
      int CID = c->Index;
      //free(index);
      char buf[1024+1];// this size may enough
      char cmd[16];//Command Name
      char str[1024];
      SOCKET s=Connection[CID]->Socket;
      //say hello first
      //printf("%s",Server[CID]->WelcomeText);
      sprintf(str,"220 %s\r\n\0",Server[c->ServerID]->WelcomeText);
      //printf("OK.\r\n",CID);
      if(!Send(s,str))
                                            return false;
      //printf("%s\r\n",Server[CID]->WelcomeText);
      while(FTPOK)
      {
         int ret = 0;
         ret = recv( s, buf, 1024, 0 );
         if(ret>0)
         {
                  int iSpace,i;
                  //buf[ret+1]='\0';//set the end symbol
                  //printf("%s",buf);
                  for(iSpace=0;(buf[iSpace]!=' ')&&(buf[iSpace]!='\r')&&(buf[iSpace]!='\n')&&(iSpace<=ret);iSpace++)
                  //it is better than strchr
                         ;//Do you think we will do something here
                  strncpy(cmd,buf,iSpace);
                  cmd[iSpace]='\0';
                  //printf("%d,%s",iSpace,cmd);
                  strcpy(cmd,strupr(cmd));  //To Upper..
                  //Get Argvs
                  iSpace++;
                  for(i=iSpace;i<ret&&buf[i]!='\n'&&buf[i]!='\r';i++)
                          buf[i-iSpace]=buf[i];
                  //printf("%d,%d",buf[ret-1],buf[ret]);
                  buf[i-iSpace]='\0';
                  
                  #ifdef Printer
                  printf("<<%d:%s %s\r\n",s,cmd,buf);
                  #endif
                  int CMD=GetCommandID(cmd);
                  /* Compare */
                  if(CMD==TOK_ERROR){
                      Send(s,"500 Syntax error, command unrecognized.\r\n");
                      continue;
                  }
                  if(Connection[CID]->State==NotLogged&&CMD>TOK_PASS){
                       Send(s,"530 Please login with USER and PASS.\r\n");
                       continue;
                  }
                  if(Connection[CID]->State!=NotLogged&&c->State!=Logged){
                  Send(s,"500 Reading.\r\n");
                  continue;
                  }
                  
                  Connection[CID]->TickCount=0;
                  switch(CMD){
                  case TOK_USER:
                      Connection[CID]->State=NotLogged;
                      Connection[CID]->UserID=GetUserByName(buf);
                      sprintf(str,"331 Password required for %s\r\n",buf);
                      Send(s,str);
                      break;
                  case TOK_PASS:
                      if(c->UserID>=0)
                      {
                          if( (strcmp(User[Connection[CID]->UserID]->PassWord,buf)==0&&User[Connection[CID]->UserID]->Enabled)||
                          strlen(User[Connection[CID]->UserID]->PassWord)==0 )
                          {
                               if(User[Connection[CID]->UserID]->OnlineConnections >=User[Connection[CID]->UserID]->MaxConnections)
                               {
                                    Send(s,"530 Not logged in, too many people are using this user.\r\n");
                                    break;     
                               }
                               User[Connection[CID]->UserID]->OnlineConnections++ ;
                               Connection[CID]->State=Logged;
                               strcpy(Connection[CID]->CurrentDirectory,"/");
                               strcpy(Connection[CID]->LocalDirectory,User[Connection[CID]->UserID]->Directory[0]->Local);
                               
                               Send(s,"230 User successfully logged in.\r\n");
                          }else
                               Send(s,"530 Not logged in, user or password incorrect.\r\n");
                      }else
                           Send(s,"530 Not logged in, user or password incorrect!\r\n");
                      break;
                  case TOK_PWD:
                      sprintf(str,"257 \"%s\" is current directory.\r\n",c->CurrentDirectory);
                      Send(s,str);
                      break;
                  case TOK_TYPE:
                       sprintf(str,"200 Type set to %s\r\n",buf);
                       Send(s,str);
                       break;
                  case TOK_SYST:
                       Send(s,"215 Windows_NT\r\n");
                       break;
                  // specify IP and port (PORT a1,a2,a3,a4,p1,p2) -> IP address a1.a2.a3.a4, port p1*256+p2. 
                  case TOK_PORT:
                  {
               			unsigned short int Num[6];
            			sscanf(buf,"%d,%d,%d,%d,%d,%d",
                        &Num[0],&Num[1],&Num[2],&Num[3],&Num[4],&Num[5]);
                        //Build IP
                        sprintf(str,"%d.%d.%d.%d",Num[0],Num[1],Num[2],Num[3]);
                        strcpy(Connection[CID]->DataRemoteIP,str);
                        Connection[CID]->DataRemotePort=Num[4]*256+Num[5];
            			Connection[CID]->PassiveMode = FALSE;
            			Send(s,"200 Port command successful\r\n");
                  }
      			  break;
      			  case TOK_PASV:
                  {
                       //closesocket(c->DataSocket);
                       if ((Connection[CID]->DataSocket = socket( AF_INET, SOCK_STREAM, IPPROTO_TCP )) == INVALID_SOCKET )
                       {
                           Send(s,"Data socket create error\r\n");
                           break;
                       }
                       SOCKADDR_IN m_sockaddr;
                       memset( &m_sockaddr,0, sizeof( m_sockaddr ) );
                       m_sockaddr.sin_family = AF_INET;
                       m_sockaddr.sin_addr.s_addr = INADDR_ANY;
                       m_sockaddr.sin_port = htons( 0 );
                       if ( bind( Connection[CID]->DataSocket, (SOCKADDR*)&m_sockaddr, sizeof( m_sockaddr ) ) == SOCKET_ERROR )
                       {
                            Send(s,"Data socket bind error.\r\n");
                            break;
                       }
                       if( listen( Connection[CID]->DataSocket, 1 ) == SOCKET_ERROR )
                       {
                            Send(s,"Data socket listen error.\r\n");
                            break;
                       }
                       int size=sizeof( m_sockaddr );
                       getsockname( Connection[CID]->DataSocket, (SOCKADDR*)&m_sockaddr, &size );
                       int port=htons( m_sockaddr.sin_port );
                       //printf("PASV ˿ڣ%d %s\r\n", htons( m_sockaddr.sin_port ), LocalIP );
                       Connection[CID]->PassiveMode=TRUE;
                       sprintf(str,"227 Entering Passive Mode (%d,%d,%d,%d,%d,%d).\r\n",
                       LocalIP[0],LocalIP[1],LocalIP[2],LocalIP[3],(int)port/256, port%256);
                       Send(s,str);
                  }
                  break;
                  case TOK_LIST:
                  {
                       Send(s,"125 Data connection already open; Transfer starting.\r\n");
                       if(!ConnectDataSocket(Connection[CID]))
                       {
                                Send(s,"ConnectDataSocket() error\r\n");
                                break;
                       }
                       char data[ MAXDIRECTORYLISTBYTES ];
                       memset(data, 0, MAXDIRECTORYLISTBYTES);
                       GetDirectoryList( Connection[CID], data );
                       if ( !Send(c->DataSocket,data ))
                       {
                          Send(s,"Data socket send error\r\n");
                          break;
                       }
                       //Sleep(100);
                       shutdown(Connection[CID]->DataSocket,0);
                       closesocket(Connection[CID]->DataSocket);
                       Send(s,"226 Transfer complete.\r\n");
                       free(data);
                       break;
                  }
                  case TOK_STOR:
                       if(!ConnectDataSocket(c))
                       {
                                Send(s,"ConnectDataSocket() error\r\n");
                                break;
                       }
                       sprintf(str,"%s/%s", Connection[CID]->LocalDirectory, buf);
                       Connection[CID]->State= Uploading;
                       Send( s,"150 Opening BINARY mode data connection for file transfer.\r\n");
                       {
                             long FileSize=0;
                             int RecvSize=DATABLOCKSIZE;
                             unsigned char buffer[DATABLOCKSIZE];
                             FILE *fp= fopen( str, "wb" );
                             if( !(fp==NULL) )
                             {
                                 setsockopt(Connection[CID]->DataSocket,SOL_SOCKET,SO_RCVBUF,(const char*)&RecvSize,sizeof(int));
                                 while(RecvSize=recv( Connection[CID]->DataSocket,buffer,DATABLOCKSIZE,0))
                                 {
                                     if (RecvSize==0)break;
                                     if (RecvSize == SOCKET_ERROR)break;
                                     fwrite(buffer,RecvSize,1,fp);
                                     //if(RecvSize==0)printf("Recv Size: %d",RecvSize);
                                     FileSize+=RecvSize;
                                     //Sleep(1);
                                 }
                                 fclose(fp);
                                 closesocket(Connection[CID]->DataSocket);
                             }else{
                                 Send( s,"226 Transfer complete,but failed.\r\n" );
                                 break;
                             } 
                       }
                       Send( s, "226 Transfer complete.\r\n" );
                       Connection[CID]->State=Logged;
                       break;
                  case TOK_RETR:
                       if(!ConnectDataSocket(Connection[CID]))
                       {
                                Send(s,"ConnectDataSocket() error\r\n");
                                break;
                       }
                       sprintf(str,"%s/%s", Connection[CID]->LocalDirectory, buf);
                       if( access( str ,0)==0){
                           Connection[CID]->State= Downloading;
                           Send( s,"150 Opening BINARY mode data connection for file transfer.\r\n");
                            {
                               long FileSize=0,SendSize=0,size;
                               FILE *fp= fopen( str, "rb" );
                               unsigned char buffer[DATABLOCKSIZE];
                               if( !(fp==NULL) )
                               {
                                   fseek(fp, 0L, SEEK_END);
                                   FileSize = ftell(fp);
                                   rewind(fp);
                                   //printf("Read file: %s. size:%d.\r\n",str,FileSize);
                                   while(SendSize < FileSize )
                                   {
                                       size=FileSize -SendSize;
                                       if( size > DATABLOCKSIZE)
                                           size= DATABLOCKSIZE; 
                                                                         
                                       if(fread( buffer, size, 1, fp)<0){
                                           Send( s,"226 Transfer complete,but failed.\r\n" );
                                           break;
                                       }
                                       if( !SendEx( Connection[CID]->DataSocket, buffer, size) )
                                       {
                                           //Error
                                           Send( s,"226 Transfer complete,but failed by SendEx.\r\n" );
                                           break;
                                       }
                                       SendSize+=size;
                                       //Sleep(0);
                                   }
                                   //Send Over
                                   fclose(fp);
                                   shutdown( Connection[CID]->DataSocket,0);
                                   closesocket(Connection[CID]->DataSocket);
                                   Send( s, "226 Transfer complete.\r\n" );
                                   //Finished
                               }else{
                                   Send( s,"226 Transfer complete,but failed.\r\n" );
                               }
                               Connection[CID]->State=Logged;
                            }
                       }else
                            Send( s,"550 File not found.\r\n");
                       break;
                  case TOK_CWD:
                       if(ChangeDirectory(c,buf)){
                          sprintf(str,"257 \"%s\" is current directory.\r\n",c->CurrentDirectory);
                          Send(s,str);
                       }else{
                          sprintf(str,"550 CWD failed. \"%s\": directory not found.\r\n",buf);
                          Send(s,str);
                       }
                       break;
                  // Get File Size
                  case TOK_SIZE:
                  {
                       sprintf(str,"%s/%s",Connection[CID]->LocalDirectory,buf);
                       long size=FileSize(str);
                       if(size>=0){
                                   sprintf(str,"213 %d\r\n",size);
                                   Send(s,str);
                       }else{
                             printf("%s\r\n",str);
                             Send(s,"550 File not found\r\n");
                       }
                  }
                  break;
                  case TOK_DELE:
                       sprintf(str,"%s/%s",Connection[CID]->LocalDirectory, buf);
                       if( remove( str) ==0 ){
                           sprintf(str,"250 File \"%s\" was deleted successfully.\r\n",buf );
                           Send( s, str );
                       }else{
                           Send( s, "550 File not found.\r\n");
                       }
                       break;
                  case TOK_RNFR:
                       sprintf(str,"%s/%s", Connection[CID]->LocalDirectory, buf);
                       if( access( str ,0)==0){
                           Send( s, "350 File exists, ready for destination name\r\n");
                           strcpy( Connection[CID]->FileName , buf);
                       }else{
                           sprintf(str ,"550 %s: The system cannot find the file specified.\r\n", buf );
                           Send( s, str);
                       }
                       break;
                  case TOK_RNTO:
                  {
                       char path[1024];
                       sprintf(path,"%s/%s", Connection[CID]->LocalDirectory, buf );
                       sprintf(str,"%s/%s", Connection[CID]->LocalDirectory, Connection[CID]->FileName );
                       if ( rename( str, path )==0 ){
                            Send ( s,"250 RNTO command successful.\r\n");
                       }else{
                            Send ( s,"550 RNTO command failed.\r\n");
                       }
                  }
                  break;
                  case TOK_RMD:
                       sprintf(str,"%s/%s", Connection[CID]->LocalDirectory, buf);
                       if( rmdir ( str)==0 )
                           Send ( s, "250 Directory deleted successfully.\r\n");
                       else
                           Send ( s, "550 Directory not found.\r\n");
                       break;
                  case TOK_MKD:
                       sprintf(str,"%s/%s", Connection[CID]->LocalDirectory, buf);
                       if( mkdir ( str)==0 )
                           Send ( s, "250 Directory created successfully.\r\n");
                       else
                           Send ( s, "550 Directory created failed.\r\n");
                       break;
                  case TOK_NOOP:
                       Send(s,"200 OK\r\n");
                       break;
                  case TOK_QUIT:
		          case TOK_BYE:
                       sprintf(str,"331 %s\r\n",Server[Connection[CID]->ServerID]->GoodByeText);
                       Send(s,str);
                       Quit(CID);
                       //printf("Thread is closed.\r\n"); //This can't run, thread is exit.
                       break;
                  default:
			           Send(s,"500 Command not implemented.\r\n");
                  }
         }else{
               //printf("Socket %d is closed.\r\n",Connection[CID]->Socket);
               Quit(CID);
               //closesocket(Connection[CID]->Socket);
               break;
         }
      }
}
