#include "FileSystem.h"
#include "time.h"

/********************************************************************/
/*																	*/
/* Function name : GetDirectory  									*/
/* Description   : Ŀ¼ļб                    				*/
/*																	*/
/********************************************************************/
void GetDirectoryList( struct _Connection *c, char *buf )
{
    //Get file list
    //local directory is ok
    //use it directly
     struct _finddata_t filesx;
     int fhandle;
     char dir[1024];
     sprintf(dir,"%s/*.*",c->LocalDirectory);
     //printf("GetDirectoryList:%s\n",dir);
     fhandle = _findfirst(dir,&filesx);
     if(fhandle == -1)
     {
          //printf("fhandle error\n");
          return;
     }
     do{
          if(filesx.attrib & _A_SUBDIR)//Ŀ¼
               BuildDirectoryUnit( buf, filesx.name, filesx.time_write);
          else
               BuildFileUnit( buf, filesx.name, filesx.time_write, filesx.size);
          //Sleep(0);
     }while(!_findnext(fhandle,&filesx));
     _findclose(fhandle);
}


/********************************************************************/
/*																	*/
/* Function name : FileExists										*/
/* Description   : Check if file or directory exists				*/
/*																	*/
/********************************************************************/
BOOL FileExists(LPCTSTR lpszFileName, BOOL bIsDirCheck)
{
	// A quick'n'easy way to see if a file exists.
	DWORD dwAttributes = GetFileAttributes(lpszFileName);
    if (dwAttributes == 0xFFFFFFFF)
        return FALSE;

	if ((dwAttributes & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY)
	{
		if (bIsDirCheck)
			return TRUE;
		else
			return FALSE;
	}
	else
	{
		if (!bIsDirCheck)
			return TRUE;
		else
			return FALSE;
	}
}


/********************************************************************/
/*																	*/
/* Function name : BuildDirectoryUnit								*/
/* Description   : Ŀ¼Ԫ				                        */
/*																	*/
/********************************************************************/
void BuildDirectoryUnit( char *buf, char * filename, time_t tim)
{
     char tmp[13];
     strftime( tmp, sizeof(tmp), "%b %d  %Y\0", localtime(&tim) ); 
     sprintf( buf, "%sdr-xr-xr-x   1 owner    group               0 %s %s\r\n", buf, tmp, filename);
     //sprintf( buf, "%sdrwx------ 1 user group 0 %s %s\n", buf, tmp, filename);
}

/********************************************************************/
/*																	*/
/* Function name : BuildFileUnit       								*/
/* Description   : ļԪ				                        */
/*																	*/
/********************************************************************/
void BuildFileUnit( char *buf, char * filename, time_t tim, size_t siz)
{
     char tmp[13];
     strftime( tmp, sizeof(tmp), "%b %d  %Y\0", localtime(&tim) ); 
     sprintf( buf, "%s-r-xr-xr-x   1 owner    group %15ld %s %s\r\n", buf, siz, tmp, filename);
     //sprintf( buf, "%s-rw-rw-rw- 1 user group %ld %s %s\n", buf, siz, tmp, filename);
}


/********************************************************************/
/*																	*/
/* Function name : ChangeDirectory         							*/
/* Description   : ı䵱ǰĿ¼                 			        */
/*																	*/
/********************************************************************/
bool ChangeDirectory(struct _Connection *c, char *ChangeTo)
{
     //make unix style
     int i,j,len;
     char str[1024];
     len=strlen(ChangeTo);
     for(i=0;i<len;i++)
         if(ChangeTo[i]=='\\')
             ChangeTo[i]='/';
     if(ChangeTo[len-1]=='/')ChangeTo[len-1]='\0';
     len=strlen(ChangeTo);
     if(ChangeTo[0]=='/')
     {
        for(i=0;i<len-1;i++)
            ChangeTo[i]=ChangeTo[i+1];
        ChangeTo[len-1]='\0';
     }
     //printf("%s\n",ChangeTo);
            
     //if(strlen(ChangeTo)==0)strcpy(ChangeTo,"/");
     
     //Change 
     if(strlen(ChangeTo)==0)
     {//To root
         strcpy(c->LocalDirectory,User[c->UserID]->Directory[0]->Local);
         strcpy(c->CurrentDirectory,"/");
         return true;
     }
     //At current dir
     sprintf(str,"%s/%s",c->LocalDirectory,ChangeTo);
     if(FileExists(str,true))
     {
         sprintf(c->LocalDirectory,"%s",str);
         sprintf(c->CurrentDirectory,"%s%s",c->CurrentDirectory,ChangeTo);
         return true;
     }
     //At default dir
     sprintf(str,"%s/%s",User[c->UserID]->Directory[0]->Local,ChangeTo);
     if(FileExists(str,true))
     {
         sprintf(c->LocalDirectory,"%s",str);
         sprintf(c->CurrentDirectory,"/%s",ChangeTo);
         return true;
     }
     //At Virtual Directory
     //Get First Folder
     
     return false;
}


/********************************************************************/
/*																	*/
/* Function name : FileSize           								*/
/* Description   : ļС				                        */
/*																	*/
/********************************************************************/

long FileSize(const char *file)
{
     HANDLE hFile;
     hFile=CreateFile(file,
        GENERIC_READ,
        FILE_SHARE_READ,
        NULL,
        OPEN_EXISTING,
        0, 
        NULL);
     if(!hFile)
               return -1;
     long size=GetFileSize(hFile,NULL);
     CloseHandle(hFile);
     return size;
}
